﻿--[[
Addon: 			Bang! Inner Fire
Description:    Tracking and Alerts for Inner Fire
Author:			Bangerz of Jubei'Thos (Oceanic)
Website:        BangCraft.com
TranslateRU:    Getaddon.com
Release Build: 3.03.03

To use a custom sound, replace Custom.wav in the addon folder.

]]--

BangInnerFire = LibStub("AceAddon-3.0"):NewAddon("BangInnerFire", "AceEvent-3.0", "AceConsole-3.0", "AceComm-3.0")
local self = BangInnerFire
local optionsFrame
local addonversion = 30303
local addonname = "BangInnerFire"

function BangInnerFire:OnInitialize()

local defaults = {
   profile = {
   Enabled=true,
   Expiry=true,
   Charges=false,
   Sound=false,
   SCT="Zone",
   Textmessage="Внутренний огонь!",
   soundfile="Bell",
   PurgeR="0.2",
   PurgeG="0.5",
   PurgeB="0.9",
   ChargeN=3,
   }
}

  options = {
    type="group",
    name = "Бум! Внутренний огонь",
    childGroups = "tab",
    plugins = {},
    args = {

			enable = {
           		 type = "toggle",
           		 name = "Предупредить об окончании",
           		 desc = "Предупредить об окончании",
    		     get=function() return self.db.profile.Expiry end,
    	         set=function(info, v) self.db.profile.Expiry=v end,
                order=2,
              },
              enableiol = {
           		 type = "toggle",
           		 name = "Мало зарядов",
           		 desc = "Сообщить о малом количестве оставшихся зарядов",
    		     get=function() return self.db.profile.Charges end,
    	         set=function(info,v) self.db.profile.Charges=v end,
                order=3,
              },
              enablehozw = {
           		 type = "toggle",
           		 name = "Включено",
           		 desc = "Бум! Внутренний огонь Включен",
    		     get=function() return self.db.profile.Enabled end,
    	         set=function(v) BangInnerFire:SetEnabled() end,
                order=1,
              },

              enablesound = {
           		 type = "toggle",
           		 name = "Звук",
           		 desc = "Проигрывать звук при сообщении",
         		  get=function() return self.db.profile.Sound end,
    			set=function(info,value) self.db.profile.Sound=value end,
                order=5,
              },

              selects = {
            		type = "select",
           			 name = "Вывод",
           		 	desc = "Куда выводим сообщение?",
					values = {SCT= "Blizzard SCT / SCT / Parrot / MSBT", Zone = "Близзардовское окошко", None = "Нету"},
                    get=function() return self.db.profile.SCT end,
    				set=function(info, value) self.db.profile.SCT=value end,
                	order=6,
                 width="full",
                },
                selectzs44 = {
            		type = "select",
           			 name = "Файл звука",
           		 	desc = "Выбирите звук",
					values = {Beep = "Beep", Bell = "Bell", Custom = "Custom", HHLaugh="Headless Horseman Laugh", VengeanceBurns="Vengeance Burns!", None = "Без"},
                    get=function() return self.db.profile.soundfile end,
    				set=function(info, value) self.db.profile.soundfile=value end,
                	order=10,
                 width="full",
                },
                mess = {
            		type = "input",
           			 name = "Сообщение",
           		 	desc = "Это показует при исчезновении",
                    get=function() return self.db.profile.Textmessage end,
    				set=function(info, value) self.db.profile.Textmessage=value end,
                	order=12,
                 width="full",
                },

                  folcolour = {
            		type = "color",
           			 name = "Цвет сообщения",
    				get=function() return self.db.profile.PurgeR, self.db.profile.PurgeG, self.db.profile.PurgeB end,
    				set=function(info,r,g,b,a) self.db.profile.PurgeR, self.db.profile.PurgeG, self.db.profile.PurgeB = r,g,b
										  end,
                	order=50,
                },


                ifcharge= {
            type = "range",
            name = "# Заряды Внутреннего огня",
            desc = "Сообщать когда заряды падают ниже этого значения",
            min = 0,
            max = 30,
            step = 1,
			order = 55,
            get = function()
				return self.db.profile.ChargeN
				end,
			set = function(info, value)
			    valuez = value
    			self.db.profile.ChargeN=valuez
				end
			},

         	   }, }

    self:RegisterChatCommand("bif", "ChatCommand")
    self:RegisterChatCommand("BangInnerFire", "ChatCommand")
 	self.db = LibStub("AceDB-3.0"):New("BangInnerFireDB", defaults, "Default")
    LibStub("AceConfig-3.0"):RegisterOptionsTable("BangInnerFire", options)
    optionsFrame = LibStub("AceConfigDialog-3.0"):AddToBlizOptions("BangInnerFire", "BangInnerFire")


end

function BangInnerFire:ChatCommand(input)
    if not input or input:trim() == "" then
        InterfaceOptionsFrame_OpenToCategory("BangInnerFire")
    else
        BangInnerFire:slashHandler(input)
    end
end

function BangInnerFire:slashHandler(input)
local self = BangInnerFire
    InterfaceOptionsFrame_OpenToFrame("BangInnerFire")
end

function BangInnerFire:SetEnabled()
	if (self.db.profile.Enabled) then
		self.db.profile.Enabled = false
	else
		self.db.profile.Enabled = true
	end
end

function BangInnerFire:OnEnable()
self:RegisterEvent("COMBAT_LOG_EVENT_UNFILTERED")
DEFAULT_CHAT_FRAME:AddMessage("|cFFFFFF00Бум!IF: Загружен.|r Больше русских аддонов на |cFFFFFF00GetAddon.com|r")
end

function BangInnerFire:DoAlert()

		if not (self.db.profile.Textmessage) then
		    textmessage = "Внутренний огонь!"
        else
        	textmessage = self.db.profile.Textmessage

		end

		if self.db.profile.SCT == "Zone" then
				expirationTime = 0
				duration = 0
	    		ZoneTextString:SetText(textmessage);
				ZoneTextFrame.startTime = GetTime()
				ZoneTextFrame.fadeInTime = 0
				ZoneTextFrame.holdTime = 1
				ZoneTextFrame.fadeOutTime = 2
				ZoneTextString:SetTextColor(0, 1, 0);
				PVPInfoTextString:SetText("");
				ZoneTextFrame:Show()
        end

		if self.db.profile.SCT == "SCT" then

				if (BangInnerFire:hasMSBT()) then
						 MikSBT.DisplayMessage(textmessage,  nil, 1, self.db.profile.PurgeR*255, self.db.profile.PurgeG*255, self.db.profile.PurgeB*255, 30, nil, 5)
				end

				if (BangInnerFire:hasParrot()) then
						Parrot:ShowMessage(textmessage, nil, 1, self.db.profile.PurgeR*255, self.db.profile.PurgeG*255, self.db.profile.PurgeB*255, nil, nil)
				end

				if (BangInnerFire:hasSCT()) then
						SCT:DisplayText(textmessage, {r = self.db.profile.PurgeR, g = self.db.profile.PurgeG, b = self.db.profile.PurgeB}, false, "event", 1, anitype)
				end

				if( IsAddOnLoaded("Blizzard_CombatText"))  then
						 CombatText_AddMessage(textmessage, COMBAT_TEXT_SCROLL_FUNCTION, self.db.profile.PurgeR, self.db.profile.PurgeG, self.db.profile.PurgeB)
				end
		end



			if (self.db.profile.soundfile == "Beep") and (self.db.profile.Sound) then
				 PlaySoundFile("Sound\\Doodad\\SimonGame_SmallRedTree.wav")

			elseif (self.db.profile.soundfile == "Bell") and (self.db.profile.Sound) then
				 PlaySoundFile("Sound\\Doodad\\BellTollHorde.wav")

            elseif (self.db.profile.soundfile == "Custom") and (self.db.profile.Sound) then

				 PlaySoundFile("Interface\\AddOns\\BangInnerFire\\Custom.wav")
			elseif (self.db.profile.soundfile == "VengeanceBurns") and (self.db.profile.Sound) then

				 PlaySoundFile("Sound\\Creature\\PrinceKaelthasSunstrider\\BROKENKAELPHOENIX.wav")
			elseif (self.db.profile.soundfile == "HHLaugh") and (self.db.profile.Sound) then

				 PlaySoundFile("Sound\\Creature\\HeadlessHorseman\\Horseman_Laugh_02.wav")
			end

end

function BangInnerFire:COMBAT_LOG_EVENT_UNFILTERED(aa, timestamp, event, cc, sourceName, sourceFlags, destGUID, destName, destFlags, spellID, a, b, extraSpellID, extraSpellName)
local localizedClass, englishClass = UnitClass("player")
if not (englishClass=="PRIEST") then
   return
end

    local IFName = GetSpellInfo(10952)

    if ((event == "SPELL_DAMAGE") or (event == "SWING_DAMAGE") or (event == "RANGE_DAMAGE")) and ((self.db.profile.Enabled == true) and (self.db.profile.Charges == true)) and sourceName==UnitName("player")  then
    
       		for i=1,40 do
				local name, rank, icon, count, debuffType, duration, expirationTime, isMine, isStealable = UnitAura("player",i,"HELPFUL")
        	    if  (name == IFName) and (self.db.profile.Enabled == true) and (self.db.profile.Charges == true) and  (count) then

				 if not BangInnerFireChargeSpam then BangInnerFireChargeSpam = 1 end
				 if (count < self.db.profile.ChargeN) and (GetTime()>BangInnerFireChargeSpam)  then
				     BangInnerFireChargeSpam=GetTime()+30
				     BangInnerFire:DoAlert()
				 end

                end
            end
    end
	if spellID==588 or spellID==7128 or spellID==602 or spellID==1006 or spellID==10951 or spellID==10952 or spellID==25431 or spellID==48040 or spellID==48168 and sourceName==UnitName("player") then
    local IFName2 = GetSpellInfo(spellID)
	if (event == "SPELL_AURA_REMOVED") and ((self.db.profile.Enabled == true) and (self.db.profile.Expiry == true)) and ((spellID == 10952) or (IFName2==IFName)) then
        BangInnerFire:DoAlert()
	end
	end
end




function BangInnerFire:hasMSBT()
			if(IsAddOnLoaded("MikScrollingBattleText"))  then
            return true
		     else
			return false
			end
end
function BangInnerFire:hasParrot()
			if(IsAddOnLoaded("Parrot"))  then
            return true
		     else
			return false
			end
end
function BangInnerFire:hasSCT()
			if((IsAddOnLoaded("ScrollingCombatText")) or (IsAddOnLoaded("SCT Options")) or (IsAddOnLoaded("SCT"))) then
            return true
		     else
			return false
			end
end